public class HelloClient {

  public static void main(String[] args) {
    if (args.length != 1) {
      System.out.println("You must pass the URL of the remote HelloServer such as rmi://clio.unice.fr/HelloServer");
      System.exit(1);
    }
    Hello remoteHelloServer = null;
    if (System.getSecurityManager() == null) { 
      //System.setSecurityManager(new java.rmi.RMISecurityManager()); 
    } 
    // get a remote reference (a stub) on the remote server
    try {
      remoteHelloServer = (Hello) java.rmi.Naming.lookup(args[0]);
    } catch (SecurityException e) { 
      System.out.println("!!! --> A SecurityManager has been installed but the policy file has not been set properly");
    } catch (java.rmi.NotBoundException e) {
      System.out.println("!!! --> HelloServer not bound at the given URL");
      e.printStackTrace();
    } catch (java.net.MalformedURLException e) {
      e.printStackTrace();
    } catch (java.rmi.UnknownHostException e) {
      e.printStackTrace();
    } catch (java.rmi.RemoteException e) {
      e.printStackTrace();
    }
    
    // use the remote reference to call the method
    if (remoteHelloServer == null) return;
    try {
      System.out.println(remoteHelloServer.sayHello());
    } catch (java.rmi.RemoteException e) {
      e.printStackTrace();
    }
  }
  
}
