public class HelloServer extends java.rmi.server.UnicastRemoteObject implements Hello {

  private final static String CURRENT_HOSTNAME = getHostName();
  private final static String REGISTRY_ENTRY_ID = "HelloServer";
  
  public HelloServer() throws java.rmi.RemoteException {
  }

  public String sayHello() {
    return  "Hello World from : " + CURRENT_HOSTNAME + "!";
  }

  public static void main(String args[]) { 
    // Create and install a security manager 
    if (System.getSecurityManager() == null) { 
      //System.setSecurityManager(new java.rmi.RMISecurityManager()); 
    } 
    HelloServer helloServer = null;
    try { 
      helloServer = new HelloServer(); 
    } catch (java.rmi.RemoteException e) { 
      System.out.println("!!! --> Cannot instantiate the HelloServer"); 
      e.printStackTrace();
      return;
    } 
    try {
      // Bind this object instance to the name "HelloServer" 
      java.rmi.Naming.rebind(REGISTRY_ENTRY_ID, helloServer); 
      System.out.println(":) HelloServer bound in registry at the url "); 
      System.out.println("   rmi://"+CURRENT_HOSTNAME+"/"+REGISTRY_ENTRY_ID); 
    } catch (SecurityException e) { 
      System.out.println("!!! --> A SecurityManager has been installed but the policy file has not been set properly"); 
      e.printStackTrace(); 
    } catch (java.net.MalformedURLException e) { 
      e.printStackTrace(); 
    } catch (java.rmi.RemoteException e) { 
      System.out.println("!!! --> There is no RMI Registry running on that host : Cannot bind the HelloServer"); 
      e.printStackTrace(); 
    } 
  }
  
  protected static String getHostName() {
    try {
       return java.net.InetAddress.getLocalHost().getHostName();
    } catch (java.net.UnknownHostException e) {
       return "Unknown";
    }
  }
}
