package chat.server;

import chat.remote.RemoteClient;
import chat.remote.RemoteServer;
import chat.remote.RemoteConnection;

import java.rmi.Naming;
import java.rmi.server.UnicastRemoteObject;

/** Implementation of Server */
public class RemoteServerImpl extends UnicastRemoteObject implements RemoteServer {

  private static final String SERVER_NAME = "Server";

  private Server chatServer;

  //
  // -- CONSTRUCTORS -------------------------------------------------
  //

  public RemoteServerImpl() throws java.rmi.RemoteException {
    chatServer = new ServerImpl();
  }  
  //
  // -- PUBLIC METHODS -------------------------------------------------
  //

  public static void main(String[] args) {
    try {
      if (args.length < 1) {
        System.out.println("You must give the name of the server as an argument");
        System.exit(1);
      }
      String serverName = args[0];
      // Create and install a security manager
      if (System.getSecurityManager() == null) {
        System.setSecurityManager(new java.rmi.RMISecurityManager());
      }
      RemoteServerImpl obj = new RemoteServerImpl();
      Naming.rebind(serverName, obj);
      System.out.println("Server bound in registry under URL ");
      System.out.println("   rmi://"+getHostName()+"/"+serverName);
    } catch (Exception e) {
      System.out.println("ServerImpl err: " + e.getMessage());
      e.printStackTrace();
    }
  }


  //
  // -- implements RemoteServer -------------------------------------------------
  //

  public RemoteConnection logon(String name, RemoteClient client) throws java.rmi.RemoteException {
    // ***********************
    // placez ici l'implementation de la method logon qui cree une RemoteConnectionImpl et la retourne au client
    // ***********************
    return null;
  }


  //
  // -- PRIVATE METHODS -------------------------------------------------
  //

  private static String getHostName() {
    try {
       return java.net.InetAddress.getLocalHost().getHostName();
    } catch (java.net.UnknownHostException e) {
       return "Unknown";
    }
  }

}
